import numpy as np


class ScenarioGenerator:
    def __init__(self, target_mom, target_corr, num_scenarios, name=None):
        self.num_variables = len(target_mom[0])
        self.num_scenarios = num_scenarios
        self.mean = target_mom[0]
        self.std = target_mom[1]**0.5
        self.name = name

    def run(self):
        scenarios = []
        for i in range(self.num_variables):
            scenarios.append(np.random.normal(self.mean[i], self.std[i], self.num_scenarios))
        message = "Generated {} scenarios".format(self.num_scenarios)
        print(message + ("." if self.name is None else " for {}.".format(self.name)))
        return np.array(scenarios)
